
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <mem.h>

#include "cgdk.h"
#include "svga.h"
#include "lin.h"
#include "array.h"
#include "pal.h"
#include "pcx.h"
#include "scroll.h"
#include "mouse.h"
#include "mir.h"
#include "timer.h"
#include "keyb.h"
#include "file.h"
#include "dith.h"
#include "tm.h"
#include "car.h"
#include "dpmi.h"
#include "vsb.h"
#include "timer.h"

//extern int allocs;
//extern int frees;

#include "losa_.cpp"

#define SAVEPCX_NAME "demo"
#define DITHER_FILENAME "demo.cdt"

#ifdef __TURBOC__
  #define BALL_MAX 5
  #define BALL_LIMIT 32
#else
  #define BALL_MAX 25
  #define BALL_LIMIT 256
#endif

#define FONT_FILENAME "scifi.csf"
#define BALL_FILENAME "moon.csf"

#define HELP_LINE "F1=Help"
#define MEM_LINE_LEN 80
#define TIMER_LINE "Time total : 0000000000"
#define TIMER_LEN_STR "10"

#define CLOCK_SPEED_FAST 33
#define MOUSE_FILENAME "MOUSE_W.CSF"
#define ARROW_FILENAME "MOUSE.CSF"

#define DITHER_ALLOC_COLORS 6

#define SCROLL_SHIFTSLOW 1/4
#define SCROLL_SHIFTFAST 2
#define SCROLL_DX 4
#define SCROLL_DY 4

#define ARROW_SHIFT 1/4
#define ARROW_DX 4
#define ARROW_DY 4

#define BALL_SPEED 4

#define SPR_SIZEX 16
#define SPR_SIZEY 16
#define SPR_SIZE (SPR_SIZEX*SPR_SIZEY)

#ifdef __TURBOC__
  #define MAP_MAXX 50
  #define MAP_MAXY 50
  #define MAXMASKSPR 150
  #define MAXSPR 200
  #define REDRAW_MAXX 25
  #define REDRAW_MAXY 30
#else
  #define MAP_MAXX 250
  #define MAP_MAXY 250
  #define MAXMASKSPR 250
  #define MAXSPR 250
  #define REDRAW_MAXX 50
  #define REDRAW_MAXY 50
#endif

int svgaBankSwitchTime;
char bankSwitchS [80];
long bankCount;
double graphFreq;
double textFreq;

int videoMode;
int clockSpeed;

TMIR *arrow_mir;
int arrow_x, arrow_y;

TCSF *mouse_csf, *arrow_csf;

long walkPhase;
int panelsOn=1;

TCSF *fnt;
int time_length,time_width,time_size;
void *time_buf;
TMIR *time_mir;

int help_length,help_width,help_size;
void *help_buf;
TMIR *help_mir;

int mem_length,mem_width,mem_size;
void *mem_buf;
TMIR *mem_mir;

TCAR *carHandle;

char *videoBuf;
void far *frameBuffer;

int ballMax;
int ball_x [BALL_LIMIT];
int ball_y [BALL_LIMIT];
int ball_xplus [BALL_LIMIT];
int ball_yplus [BALL_LIMIT];
TCSF *ball_csf;
TMIR *ball_mir [BALL_LIMIT];
int ball_updateCount; // = BALL_MAX;

TRGBColor pal [256];

void *MAP;
void *SPR;
void *MASKSPR;
void *MASKMAP;

int savePCXCount;

char *mask;

static void meminfo (void)
{
  printf ("Memory available total : %8lu bytes\n", _mtotal);
  printf ("Memory allocated       : %8lu bytes\n", _mallocated);
  printf ("Memory free            : %8lu bytes\n", (_mallocated > _mtotal) ? 0 :_mfree);
  printf ("Low memory allocated   : %8lu bytes\n",DPMI_allocated);
}

static void printMem (void)
{
  #ifdef __TURBOC__
  printf ("Memory allocated : %lu bytes\n", _mallocated);
  #endif
}


static void ballCount (int *x, int *y, int *xplus, int *yplus,int xmax, int ymax)
{

  if (((*x)+(*xplus) <= 0) || ((*x)+(*xplus) >= xmax))
  {
    (*xplus) = -sign((*xplus))*((rand () % BALL_SPEED)+1);
  }

  if (((*y)+(*yplus) <= 0) || ((*y)+(*yplus) >= ymax))
  {
    (*yplus) = -sign((*yplus))*((rand () % BALL_SPEED)+1);
  }

  (*x) += (*xplus);
  (*y) += (*yplus);
}



static void walkRestoreMIR (void)
{
  int i;

  MIR_restore (arrow_mir);
  MIR_restore (help_mir);
  MIR_restore (time_mir);
  MIR_restore (mem_mir);
  MOUSE_hideCursor ();
  for (i = 0; i < ballMax; i++)
  {
    MIR_restore (ball_mir [i]);
  }
}


static void walkRedraw (void)
{
  if (MOUSE_info.buttons.left)
  {
    walkRestoreMIR ();
    SCROLL_flush ();
    PAL_clear (0, 256);
    SCROLL_redraw (walkPhase % REDRAW_MAXX, walkPhase % REDRAW_MAXY, -1, -1);
    PAL_set (pal, 0, 256);
    while (MOUSE_info.buttons.left)
      ;
//    MIR_update (arrow_mir, SVGA_maxX/2, SVGA_maxY/2);
  }
  if (MOUSE_info.buttons.right)
  {
    walkRestoreMIR ();
    SCROLL_flush ();
    PAL_clear (0, 256);
    SCROLL_redraw (-1, -1, -1, -1);
    PAL_set (pal, 0, 256);
    while (MOUSE_info.buttons.right)
      ;
//    MIR_update (arrow_mir, SVGA_maxX/2, SVGA_maxY/2);
  }
}


static void walkUpdateTimer (void)
{
  char s [100];

  sprintf (s, "Time total : %"TIMER_LEN_STR"li\n"
              "Time       : %"TIMER_LEN_STR"li", TIMER_timeTotal, TIMER_time);
  memset (time_buf, 0, time_size);
  CSF_cpyText (fnt, s, time_buf, 0, 0, time_length, time_width);
  MIR_changeSpr (time_mir, time_buf);
}

static void walkUpdateMem (void)
{
  char str [256];

  sprintf (str, "%lu total,%lu allocated,%lu free,%lu kB low memory allocated.\n",
           (unsigned long)_mtotal/1024, (unsigned long)_mallocated/1024, (unsigned long)_mfree/1024,
           DPMI_allocated/1024);
  memset (mem_buf, 0, mem_size);
  CSF_cpyText (fnt, str, mem_buf, 0, 0, mem_length, mem_width);
  MIR_changeSpr (mem_mir, mem_buf);
}

static void walkUpdateMouse (void)
{
  if (KEYB_pressed (KEY_M))
  {
    MOUSE_setCursor (arrow_csf, 0);
  }
  else
  {
    if ((walkPhase % clockSpeed) == 0)
    {
      MOUSE_setCursor (mouse_csf, walkPhase/clockSpeed);
    }
  }

  if (KEYB_pressed (KEY_SPACE))
  {
    MOUSE_hideCursor ();
  }
  else
  {
    MOUSE_showCursor ();
  }
  MOUSE_updateCursor ();
}


static void walkUpdateArrow (void)
{
  int ax, ay;

  ax = ay = 0;
  if (KEYB_pressed (KEY__4))
    ax-=ARROW_DX;
  if (KEYB_pressed (KEY__6))
    ax+=ARROW_DX;
  if (KEYB_pressed (KEY__8))
    ay-=ARROW_DY;
  if (KEYB_pressed (KEY__2))
    ay+=ARROW_DY;
  if (KEYB_shifted)
  {
    ax = ax*ARROW_SHIFT;
    ay = ay*ARROW_SHIFT;
  }
  arrow_x += ax;
  arrow_y += ay;

  MIR_updateDelta (arrow_mir, ax, ay);

  if (KEYB_pressed (KEY_ENTER))
  {
    MIR_restore (arrow_mir);
  }
//  else
//  {
//    MIR_updateDelta (arrow_mir, ax, ay);
//  }
}

static void walkUpdateBalls (void)
{
  int i;

  for (i = 0; i < ballMax; i++)
  {
    if (i < ball_updateCount)
      ballCount (&ball_x[i],&ball_y[i],&ball_xplus[i],&ball_yplus[i],SVGA_maxX,SVGA_maxY);
    MIR_update (ball_mir [i], ball_x[i], ball_y[i]);
  }
}

static void walkUpdateMIR (void)
{
  walkUpdateMouse ();

  if (panelsOn)
  {
    MIR_update (time_mir, SVGA_maxX-time_length-fnt->sizeX, 0);
    MIR_update (help_mir, 0, 0);
    MIR_update (mem_mir, 0, SVGA_maxY-mem_width);
  }
  else
  {
    MIR_restore (help_mir);
    MIR_restore (time_mir);
    MIR_restore (mem_mir);
  }

  walkUpdateBalls ();
  walkUpdateArrow ();
}




static void walkUpdateSCROLL (void)
{
  int mx, my;

  mx = my = 0;
  if (KEYB_pressed (KEY_LEFT))
    mx-=SCROLL_DX;
  if (KEYB_pressed (KEY_RIGHT))
    mx+=SCROLL_DX;
  if (KEYB_pressed (KEY_UP))
    my-=SCROLL_DY;
  if (KEYB_pressed (KEY_DOWN))
    my+=SCROLL_DY;

  if (KEYB_ctrl)
  {
    mx = mx*SCROLL_SHIFTSLOW;
    my = my*SCROLL_SHIFTSLOW;
  }

  if (KEYB_alt)
  {
    mx = mx*SCROLL_SHIFTFAST;
    my = my*SCROLL_SHIFTFAST;
  }

  SCROLL_update (mx, my);
}


static void savePCX (void)
{
  char saveName [20];

  if (videoBuf != NULL)
  {
    SVGA_getWinNoVSB (videoBuf, 0, 0, SVGA_maxX, SVGA_maxY, SVGA_maxX);

    do
    {
      sprintf (saveName, SAVEPCX_NAME"%04i.pcx", savePCXCount),
      savePCXCount++;
    }
    while (F_exist (saveName));

    PCX_save (saveName, videoBuf, SVGA_maxX, SVGA_maxY, pal);
  }
}

static void onlinehelp (void)
{
  walkUpdateMIR ();
  SCROLL_flush ();
  #ifndef __TURBOC__
    DITH_shadeScreen (-5);
  #else
    DITH_shadeScreen (1);
  #endif
  CSF_print (fnt, "+--------------------------------------+\n"
                  "| Welcome to the CGDK (tm) Demo Help ! |\n"
                  "+--------------------------------------+\n"
                  "\n"
                  "F1           = Help (this screen)\n"
                  "F2           = Start timer\n"
                  "F3           = Stop timer\n"
                  "F4           = Reset timer\n"
                  "[+]          = Move next ball\n"
                  "[-]          = Stop next ball\n"
                  "Arrows       = Scroll screen\n"
                  "    (Hold Alt and Ctrl to change speed)\n"
                  "[Arrows]     = Move arrow\n"
                  "    (Hold Shift to slow down\n"
                  "Spacebar     = Hide mouse cursor\n"
                  "Enter        = Hide arrow\n"
                  "R            = Refresh screen\n"
                  "M            = Change mouse cursor\n"
                  "Left button  = Random redraw screen\n"
                  "Right button = Redraw screen\n"
                  "Pause        = Just guess\n"
                  "Print screen = Save screen to a PCX file\n"
                  "Escape       = Exit\n"
                  "\n"
                  "Press any key to continue ... \n", 0, 5);
  SVGA_flush ();
  KEYB_wait ();
  PAL_clear (0, 256);
  SCROLL_redraw (-1, -1, -1, -1);
  PAL_set (pal, 0, 256);
}

static void redraw (void)
{
  if (videoBuf != NULL)
  {
    SVGA_getWinNoVSB (videoBuf, 0, 0, SVGA_maxX, SVGA_maxY, SVGA_maxX);
    walkRestoreMIR ();
    SVGA_putWin_ (videoBuf, 0, 0, SVGA_maxX, SVGA_maxY, SVGA_maxX);
  }
}

#define MOUSE_SENSMIN 2
#define MOUSE_SENSDEFAULT 12 // less value - greater speed
#define MOUSE_SENSMAX 22
#define MOUSE_SENSSTEP 2

int mouseSens = MOUSE_SENSDEFAULT;

static int walkUpdateKeyb (void)
{
  char c;
  int i;

  switch (KEYB_get ())
  {
    case KEY_F1:
    {
      onlinehelp ();
      break;
    }
    case KEY_F2:
      TIMER_start ();
      break;
    case KEY_F3:
      TIMER_stop ();
      break;
    case KEY_F4:
      TIMER_reset ();
      break;
    case KEY_R:
      redraw ();
      break;

    case KEY_PRTSC:
    {
      savePCX ();
      break;
    }


    case KEY_PLUS:
    {
      if (ball_updateCount < ballMax)
        ball_updateCount++;
      break;
    }
    case KEY_MINUS:
    {
      if (ball_updateCount > 0)
        ball_updateCount--;
      break;
    }

    case KEY_PAUSE:
    {
      while (KEYB_wait () == KEY_PAUSE)
        ;
      break;
    }
    case KEY_ESC:
    {
      walkUpdateMIR ();
      SCROLL_flush ();
      return 1;
    }

    case KEY__MINUS:
    {
      if (mouseSens+MOUSE_SENSSTEP <= MOUSE_SENSMAX)
        mouseSens+=MOUSE_SENSSTEP;
      MOUSE_setSensitivity (mouseSens,mouseSens);
      break;
    }
    case KEY__PLUS:
    {
      if (mouseSens-MOUSE_SENSSTEP >= MOUSE_SENSMIN)
        mouseSens-=MOUSE_SENSSTEP;
      MOUSE_setSensitivity (mouseSens,mouseSens);
      break;
    }

    case KEY_P:
    {
      if (panelsOn)
      {
        panelsOn = 0;
      }
      else
      {
        panelsOn = 1;
      }
    }
  }
  return 0;
}

static void MAIN_walkMap (void)
{
  // PAL_fadeIn (pal);

  walkPhase = 0;

  while (walkUpdateKeyb () == 0)
  {
    if (!KEYB_flags.scrollLock)
    {
      walkRedraw ();
      walkUpdateTimer ();
      walkUpdateMem ();
      walkUpdateMIR ();
      walkUpdateSCROLL ();
    }
    else
    {
      walkRedraw ();

      if ((walkPhase % 2) == 0)
      {
        SVGA_wait (1);
      }
      else
      {
        walkUpdateMIR ();
        walkUpdateTimer ();
        walkUpdateMem ();
        walkUpdateSCROLL ();

//        SCROLL_update (0, 0);
      }
    }
    walkPhase++;
  }
  // PAL_fadeAway (pal);
}


static void MAIN_load (void)
{
  short *shortMaskMap;

  char *buf;

  buf = (char *) _malloc ((unsigned)2*255*MAP_MAXY,
                   "Not enough memory for temporary map buffer.\n");

  MAP = (short *) _malloc ((unsigned) 2 * MAP_MAXX * MAP_MAXY,
                    "Not enough memory for level map.\n");

  if (ReadMAP (1, "map", (short *) buf, 255*MAP_MAXY))
    CGDK_exit ("Error loading level map.\n",1);

  LIN_movWin_ (MAP, 2*MAP_MAXX, buf, 2*255, 2*MAP_MAXX, MAP_MAXY);

  MASKMAP = (char *) _malloc ((unsigned) MAP_MAXX*MAP_MAXY,
                       "Not enough memory for mask map.\n");

  if (ReadMSK (1, "msk", (char *) buf, 255*MAP_MAXY))
    CGDK_exit ("Error loading level mask map.\n",4);

  LIN_movWin_ (MASKMAP, MAP_MAXX, buf, 255, MAP_MAXX, MAP_MAXY);

  _free (buf);

  shortMaskMap = A_char2short ((char *)MASKMAP, MAP_MAXX*MAP_MAXY);
  if (shortMaskMap == NULL)
    CGDK_exit ("Not enough memory to convert char mask map to short mask map.\n", EXIT_FAILURE);
  _free (MASKMAP);
  MASKMAP = shortMaskMap;

  SPR = (char *) _malloc ((unsigned) MAXSPR * SPR_SIZE,
                   "Not enough memory for level sprites.\n");

  if (ReadSPR (1, "spr", (char *) SPR, SPR_SIZEX, MAXSPR))
    CGDK_exit ("Error loading level sprites.\n",2);

  MASKSPR = (char *) _malloc ((unsigned) MAXMASKSPR * SPR_SIZE,
                       "Not enough memory for mask sprites.\n");

  if (ReadSPR (1, "mas", (char *) MASKSPR, SPR_SIZEX, MAXMASKSPR))
  {
    memset (MASKSPR, 0, SPR_SIZE*MAXMASKSPR);
//    CGDK_exit ("Error loading level mask sprites.\n",5);
  }

  if (ReadPAL (1, "pal", pal, 768))
    CGDK_exit ("Error loading level palette.\n",3);
}

static void MAIN_loadCSF (void)
{
  TRGBColor sandClockColor [6] = {255, 255,   0, 0,
                                 222,   0,   0, 0,
                                 189,   0,   0, 0,
                                 156,   0,   0, 0,
                                 123,   0,   0, 0,
                                  90,   0,   0, 0 };

  mouse_csf = CSF_new (carHandle, MOUSE_FILENAME);
  if (mouse_csf == NULL)
  {
    CGDK_exit (MOUSE_FILENAME" not found.\n", EXIT_FAILURE);
  }
  arrow_csf = CSF_new (carHandle, ARROW_FILENAME);
  if (arrow_csf == NULL)
  {
    CGDK_exit (ARROW_FILENAME" not found.\n", EXIT_FAILURE);
  }
  ball_csf = CSF_new (carHandle, BALL_FILENAME);
  if (ball_csf == NULL)
  {
    CGDK_exit (BALL_FILENAME" not found.\n", EXIT_FAILURE);
  }

  CSF_updateColors (arrow_csf,pal, 2, 254);
  if (mouse_csf->maxColor == 6)
  {
    clockSpeed = CLOCK_SPEED_FAST;
    CSF_setPal (mouse_csf, sandClockColor, 0, 6);
  }
  else
  {
    clockSpeed = 1;
  }
  CSF_updateColors (mouse_csf,pal, 2, 254);
  CSF_updateColors (ball_csf, pal, 2, 254);

  fnt = CSF_new (carHandle,FONT_FILENAME);
  if (fnt == NULL)
  {
    CGDK_exit (FONT_FILENAME" not found.\n", EXIT_FAILURE);
  }

  CSF_setXSpacing (fnt, 0);
  CSF_setYSpacing (fnt, 1);

  time_length = CSF_getTextLength (fnt, strlen (TIMER_LINE));
  time_width = CSF_getTextWidth (fnt, 2);
  time_size   = CSF_getTextSize (fnt, strlen (TIMER_LINE), 2);
  time_buf = _malloc (time_size, "Not enough memory for time mirror buffer.\n");

  help_length = CSF_getTextLength (fnt, strlen (HELP_LINE));
  help_width = CSF_getTextWidth (fnt, 1);
  help_size   = CSF_getTextSize (fnt, strlen (HELP_LINE), 1);
  help_buf = _malloc (time_size, "Not enough memory for help mirror buffer.\n");

  mem_length = CSF_getTextLength (fnt, MEM_LINE_LEN);
  mem_width = CSF_getTextWidth (fnt, 1);
  mem_size   = CSF_getTextSize (fnt, MEM_LINE_LEN, 1);
  mem_buf = _malloc (mem_size, "Not enough memory for memory info mirror buffer.\n");

  CSF_updateColors (fnt, pal, 2, 254);
}

static void MAIN_ditherInit (void)
{
  if (DITH_load (carHandle, DITHER_FILENAME) != 0)
  {
    printf ("Creating dither table ...\n");

    if ( DITH_init (6) != 0 )
      CGDK_exit ("Not enough memory for dither table.\n", EXIT_FAILURE);

    DITH_fill (pal, 1, 240, 20, 2);

    if (DITH_save (DITHER_FILENAME) != 0)
    {
      printf ("WARNING: Error saving dither table. Not enough disk space ?\n"
              "\n");
    }
  }
}

static void MAIN_initMouse (void)
{
//  MOUSE_setWindow (0,0,SVGA_maxX+mouse_csf->sizeX,SVGA_maxY+mouse_csf->sizeY);
//  MOUSE_setSensitivity (4,4);
  MOUSE_showCursor ();
}

static void MAIN_initMIR (void)
{
  int i, j;

  mask = (char *) _malloc (arrow_csf->size, "Not enough memory for arrow mirror mask.\n");

  for (j = 0; j < arrow_csf->sizeY; j++)
  {
    for (i = 0; i < arrow_csf->sizeX; i++)
    {
      mask [i+j*arrow_csf->sizeX] = (i+j) % 5;
    }
  }

  arrow_mir = MIR_new (arrow_csf->raw, arrow_csf->sizeX, arrow_csf->sizeY,
                          ballMax+2, MIR_TYPE_SHADEBOTH,mask);
  if (arrow_mir == NULL)
  {
    CGDK_exit ("Not enough memory for arrow mirror.\n", EXIT_FAILURE);
  }

  arrow_mir->x = arrow_x = SVGA_maxX/2;
  arrow_mir->y = arrow_y = SVGA_maxY/2;

  time_mir = MIR_new (time_buf, time_length, time_width, MIRL_max-2, MIR_TYPE_SHADENONE | MIR_TYPE_STATIC, NULL);
  if (time_mir == NULL)
  {
    CGDK_exit ("Not enough memory for timer mirror.\n", EXIT_FAILURE);
  }

  mem_mir = MIR_new (mem_buf, mem_length, mem_width, MIRL_max-2, MIR_TYPE_SHADENONE | MIR_TYPE_STATIC, NULL);
  if (mem_mir == NULL)
  {
    CGDK_exit ("Not enough memory for memory info mirror.\n", EXIT_FAILURE);
  }

  help_mir = MIR_new (help_buf, help_length, help_width,
                         MIRL_max-2, MIR_TYPE_SHADEMAP | MIR_TYPE_STATIC, NULL);
  if (help_mir == NULL)
  {
    CGDK_exit ("Not enough memory for help line mirror.\n", EXIT_FAILURE);
  }

  memset (help_buf, 0, help_size);
  CSF_cpyText (fnt, HELP_LINE, help_buf, 0, 0, help_length, help_width);

  for (i = 0; i < ballMax; i++)
  {
    ball_mir [i] = MIR_new (CSF_raw (ball_csf, 0),
                               ball_csf->sizeX,ball_csf->sizeY,i+1, MIR_TYPE_SHADENONE, NULL);
    ball_x [i] = SVGA_maxX/2;
    ball_y [i] = SVGA_maxY/2;
    ball_xplus [i] = (-1 + 2*(rand () % 2)) * ((rand () % BALL_SPEED)+1);
    ball_yplus [i] = (-1 + 2*(rand () % 2)) * ((rand () % BALL_SPEED)+1);
  }
}

static void MAIN_initSCROLL (void)
{
  SCROLL_setMap (MAP, MAP_MAXX, MAP_MAXY);
  if (SCROLL_setSpr (SPR, SPR_SIZEX, SPR_SIZEY) != 0)
  {
    CGDK_exit ("Not enough memory for scrolling buffers.\n", EXIT_FAILURE);
  }
  SCROLL_setMask (MASKMAP, MASKSPR);
  SCROLL_setLimit (-1, 5000, -1, 500);
//  PAL_set (pal, 0, 256);
  SCROLL_redraw (0,0,-1,-1);
  SVGA_wait (1);
  PAL_set (pal,0,256);
}

static void MAIN_initScreen (void)
{
  int i;

  // SVGA_retraceInit ();
  // textFreq = SVGA_freq;

  if (SVGA_compatible < VGA_COMPATIBLE)
  {
    CGDK_exit ("This program requires a VGA compatible videocard.\n", EXIT_FAILURE);
  }

  if ( SVGA_videoModeSupported (videoMode) != 0 )
  {
    CGDK_exit ("The specified video mode is not supported.\n", EXIT_FAILURE);
  }

//  SVGA_setVideoMode (VGA_640x400x16);

//  SVGA_setVideoMode (VESA_640x480x256);

  if (SVGA_setVideoMode (videoMode) != SVGA_SETMODE_OK)
  {
    CGDK_exit ("The specified video mode did not set correctly.\n", EXIT_FAILURE);
  }

//  SVGA_enableRetrace = 0;

  frameBuffer = SVGA_linearBuf;

  PAL_clear (0, 256);
  #ifndef __TURBOC__
  videoBuf = (char *) _malloc (SVGA_max, "Not enough memory for refresh video buffer.\n");
  #endif

  graphFreq = SVGA_freq;

  SVGA_setBankCount = 0;
  TIMER_reset ();
  TIMER_start ();
  for (i = 0; TIMER_time < 1000; i++)
  {
    SVGA_setBank (i % 4);
  }
  TIMER_stop ();
  svgaBankSwitchTime = TIMER_time;

  TIMER_reset ();
  bankCount = SVGA_setBankCount;
  SVGA_setBankCount = 0;
  SVGA_setBank (0);
}


static void MAIN_done (void)
{
  int i;

  for (i = 0; i < ballMax; i++)
  {
    MIR_free (ball_mir [i]);
  }

  MIR_free (arrow_mir);
  MIR_free (help_mir);
  MIR_free (time_mir);
  MIR_free (mem_mir);

  CSF_delete (mouse_csf);
  CSF_delete (arrow_csf);
  CSF_delete (ball_csf);
  CSF_delete (fnt);

  _free (MAP);
  _free (MASKMAP);
  _free (SPR);
  _free (MASKSPR);
  _free (time_buf);
  _free (help_buf);
  _free (mem_buf);
  _free (mask);

  if (videoBuf)
  {
    _free (videoBuf);
  }

  CAR_close (carHandle);
}

static void sugest (int mode, const char *str)
{
  if (SVGA_videoModeSupported (mode)==0)
  {
    printf ("0x%.4x - %s", mode, str);
  }
}


static void commandLineHelp (void)
{
  printf ("Syntax is: demo [mirror_count [s3bug=yes|no|auto]]\n"
          "\n"
          "  mirror_count - count of sprites to move\n"
          "  s3bug        - use s3bug=yes, if you have a S3 chipset based card with\n"
          "                 uncompatible buggy VESA BIOS extension.\n"
          "               - use s3bug=no, if you have a S3 chipset based card with\,"
          "                 compatible VESA BIOS extension.\n"
          "               - use s3bug=auto, if you have a S3 chipset based card,\n"
          "                 and you are not sure, whether you have a\n"
          "                 compatible or uncompatible VESA BIOS extension (default)\n"
          "\n"
          "Example  : demo 50 S3Bug=Yes\n");
  CGDK_exit ("", EXIT_FAILURE);
}

static void MAIN_processCommandLine (void)
{
  ballMax=BALL_MAX;

  if (_argc >= 2)
  {
    ballMax = strtol (_argv [1],NULL,0);

    if (_argc >= 3)
    {
      if (*_argv [2] == '/')
      {
        *_argv [2] = '-';
      }
      strlwr (_argv [2]);
      if (strcmp (_argv [2], "-s3bug=yes") == 0)
      {
        VESA_S3Mode = VESA_S3MODE_UNCOMPATIBLEBIOS;
      }
      else
      {
        if (strcmp (_argv [2], "-s3bug=no") == 0)
        {
          VESA_S3Mode = VESA_S3MODE_COMPATIBLEBIOS;
        }
        else
        {
          if (strcmp (_argv [2], "-s3bug=auto") != 0)
          {
            commandLineHelp ();
          }
        }
      }
      if (_argc >= 4)
      {
        commandLineHelp ();
      }
    }
  }

  ball_updateCount = ballMax;
}

static int videoModeSelect (void)
{
  char s [256];
  int mode;

  do
  {
    printf (
"--------------- Cybertek Game Development Kit video mode select ----------------");
    printf (
"------- Suggested video modes supported by your system are listed bellow -------"
"--- For complete CGDK video modes numbers list, refer the CGDK documentation ---"
"--------------------------------------------------------------------------------"
            "Number - Video mode description\n"
            "------   ----------------------\n");

    sugest (XVGA_320x240x256,
  "320*240 scrolling X mode for VGA compatible videocards\n");

    sugest (XVGA_376x282x256,
  "376*282 scrolling X mode for VGA compatible videocards\n");

    sugest (XVGA_320x480x256,
  "320*480 scrolling X mode for 100% VGA compatible videocards\n");

    sugest (XVGA_360x480x256,
  "360*480 scrolling X mode for 100% VGA compatible videocards\n");

  printf ("\n");

    sugest (VESA_640x480x256 | DOUBLE_BUFFER,
  "640*480 scrolling SVGA mode for 1M+, VESA 1.2+ compliant videocards\n");

    sugest (VESA_800x600x256 | DOUBLE_BUFFER,
  "800*600 scrolling SVGA mode for 1M+, VESA 1.2+ compliant videocards\n");

    sugest (VESA_1024x768x256 | DOUBLE_BUFFER,
  "1024*768 scrolling SVGA mode for 2M+, VESA 1.2+ compliant videocards\n");

  printf ("\n");

    sugest (VGA_320x200x256,
  "320*200 static VGA mode for VGA compatible videocards\n");

    sugest (VESA_640x480x256,
  "640*480 static SVGA mode for 512kB+, VESA 1.2+ compliant videocards\n");

    sugest (VESA_800x600x256,
  "800*600 static SVGA mode for 512kB+, VESA 1.2+ compliant videocards\n");

    sugest (VESA_1024x768x256,
  "1024*768 static SVGA mode for 1M+, VESA 1.2+ compliant videocards\n");

    printf ("\nEnter the video mode number (or just press enter to exit): ");
    gets (s);
    printf ("\n");
    if (s [0] == 0)
    {
      return 0;
    }
    mode = strtol (s, NULL,0);
    if (mode == 0)
    {
      printf ("The requested video mode number is invalid.\n\n");
    }
    if (SVGA_videoModeSupported (mode) != 0)
    {
      printf ("The requested video mode is not supported by your system.\n\n");
      mode = 0;
    }
  }
  while (mode == 0);

  return mode;
}

static void MAIN_monitor (void)
{
  long bankPerSecMax;
  long bankPerFrameMax;
  long bankPerFrame;

  printf ("\n");

  if (SVGA_compatible >= VESA_COMPATIBLE)
  {
    printf ("VESA version %i.%i compliant video card \"%s\" with\n"
            "%li kB video memory detected.\n",
             VESA_version / 256, VESA_version % 256, VESA_OEMString,
             VESA_memory/1024);

    if (VESA_S3)
      printf ("This is probably a S3 chipset based card with a buggy VESA BIOS.\n");
    if (VESA_matrox)
      printf ("This is probably a Matrox Graphics based card.\n");

    printf ("\n");
  }

  if (!frameBuffer)
  {
    if (!svgaBankSwitchTime)
    {
      strcpy (bankSwitchS, "more than");
      svgaBankSwitchTime++;
    }
    else
    {
      strcpy (bankSwitchS, "");
    }

    bankPerSecMax = (long) (1000L*bankCount) / svgaBankSwitchTime;
    bankPerFrameMax = (long) ((1000L*bankCount) / (svgaBankSwitchTime * graphFreq));
    bankPerFrame = (long)SVGA_setBankCount / TIMER_retrace;
    printf ("SVGA bank switch speed %s%li per second.\n", bankSwitchS, bankPerSecMax);
    printf ("SVGA bank switch speed %s%li per frame.\n", bankSwitchS, bankPerFrameMax);
    printf ("SVGA bank switched %li per frame (%.2f%% of processor time).\n\n", bankPerFrame, ((float)100*bankPerFrame) / bankPerFrameMax);
  }
  else
  {
    printf ("Using linear video buffer at %04X:%08X\n\n", FP_SEG (frameBuffer), FP_OFF (frameBuffer));
  }
  printf ("Timer frequency: %f Hz\n", (double) TIMER_FREQ);
  printf ("Timer running time: %li ms\n", TIMER_timeTotal);

  if (SVGA_enableRetrace)
  {
    printf ("Video retraces trapped: %li\n", TIMER_retrace);
  //  printf ("Video text mode refresh frequency: %.2f Hz.\n", textFreq);
    printf ("Video graphic mode refresh frequency: %.2f Hz.\n", graphFreq);
    printf ("Timer ticks per video frame: %.2f\n", TIMER_retraceTimeMaxF);
  //  printf ("Floating point operations: %li\n", CGDK_fp);
  //  printf ("Floating point operations per frame: %f\n", ((double) CGDK_fp) / TIMER_retrace);
  }
}

int main (void)
{
  SVGA_enableVESA = 1;

  MAIN_processCommandLine ();

  while (printf ("\n"
         "DEMO - demo of the CGDK (tm) graphics engine\n"
         "\n%s\n",CGDK_copyright),

         // we first initialize CGDK using function CGDK_init to enable detection of
         // supported video modes using SVGA_videoModeSupported function

         CGDK_init (),
         videoMode = videoModeSelect (), videoMode != 0)
  {
    // call this function to use CGDK enhanced keyboard driver.
    // note that all standard console c/c++ functions will not work
    // until you call KEYB_done
    KEYB_init ();

    // enable some CGDK debug keys
    CGDK_debug = 1;

    // do not forget to call this function AFTER installing your
    // sound system drivers and/or other program libraries,
    // otherwise, the program will hang-up !
    TIMER_init (TIMER_OLDFREQ_DEF);

    // sets maximal mirror layers count and maximal mirror sizex and sizey
    // (for mirrors using shades (not panels etc.)
    // using greater values than really needed will waste memory
    MIR_init (ballMax+5, MIR_MAXDEF_SIZE);
    meminfo ();
    printf ("\n");

    printf ("Loading CAR file ...\n");
    // opens car file. note that each car handle requires about 32k of memory !
    // use CAR_close to close car file and release allocated memory
    carHandle = CAR_open (CAR_EMULATION);
    printMem ();

    printf ("Loading maps and sprites ...\n");
    MAIN_load ();
    printMem ();

    printf ("Loading Sprite/Font files ...\n");
    MAIN_loadCSF ();
    printMem ();

    // this function will attempt to load dither table from disk
    // if does not exist, a new dither table will be created and saved
    printf ("Initializing dither table ...\n");
    MAIN_ditherInit ();
    printMem ();

    // sets the video mode and perform SVGA bank switching benchmark
    printf ("Initializing screen ...\n");
    MAIN_initScreen ();
    printMem ();

    MAIN_initMIR ();
    printMem ();
    MAIN_initMouse ();

    MAIN_initSCROLL ();
    printMem ();

    MAIN_walkMap ();

    // this function releases all memory allocated in this module
    MAIN_done ();

    // we call SVGA_restore to restore original console video mode
    SVGA_restoreVideoMode ();

    // displays system equipment profiles
    MAIN_monitor ();

    printf ("\n"
            "Cleaning up ...");
    fflush (stdout);

    // we call user and CGDK functions registered using _atexit function
    // (including CGDK_done, KEYB_done and TIMER_done)
    // to free memory, and deinitialize system devices
    // this function is called automaticaly after your application terminates
    // (for example, after call to CGDK_exit or return from main() function)
    _cexit ();

    // the amount of allocated memory should be now 0
    meminfo ();

    printf ("_?alloc called %i times, _free called %i times.\n",
            _allocCount, _freeCount);

    printf ("DPMI_alloc called %i times, DPMI_free called %i times.\n\n",
            DPMI_allocCount, DPMI_freeCount);

    printf ("Press any key to continue ...");
    fflush (stdout);
    getch ();
    printf ("\n\n");
  }

  return 0;
}
